/* 
 *	SimpApp - frame work for the most basic
 *
 *  Dialog.c - ancillary dialog routines.
 *
 *	Copyright 1994 Tom Erbe - CalArts
 */

#include <math.h>
#include <SoundInput.h>
#include "SoundFileHeader.h"
#include "OpenSoundFile.h"
#include "PAPlay.h"
#include "Play.h"
#include "Dialog.h"
#include "Main.h"

extern GlowBalls	global;

extern PAPlayInfo	gPAPlayInfo;

void	DrawErrorMessage(Str255	s)
{
	short	itemType;
	Handle	itemHandle;
	Rect	itemRect;
	
	GetDialogItem(global.errorDialog, ERROR_TEXT, &itemType, &itemHandle, &itemRect);
	SetDialogItemText(itemHandle, s);
	SelectWindow(global.errorDialog);
	DrawDialog(global.errorDialog);
	ShowWindow(global.errorDialog);
}

void	HandleAboutDialog(void)
{
	long		dialogDone = FALSE;
	Boolean	flash;
	GrafPtr	oldPort;
	char theChar;
	long	lTicks;
	
 	flash = FALSE;
 	GetPort(&oldPort);
 	SetPort(global.aboutWindow);
	ShowWindow(global.aboutWindow);
	SelectWindow(global.aboutWindow);

	lTicks = TickCount();
	DrawPicture(global.aboutPict, &global.aboutWindow->portRect);
	while(dialogDone == FALSE)
	{
		if((TickCount() - lTicks)>300)
		{
			HideWindow(global.aboutWindow);
			dialogDone = TRUE;
		}
		if(flash==TRUE)
			InvertRect(&global.aboutWindow->portRect);
		if(global.wNEpresent)
		WaitNextEvent(everyEvent, &global.theEvent, 0L, 0L);
		else
		{
			SystemTask();
			GetNextEvent(everyEvent, &global.theEvent);
		}
	
		switch(global.theEvent.what)
		{
			case keyDown:
			case autoKey:
				theChar = global.theEvent.message & charCodeMask;
				if(theChar == 'a')
					flash = TRUE;
				else
				{
					HideWindow(global.aboutWindow);
					dialogDone = TRUE;
				}
				break;
			case mouseDown:
				HideWindow(global.aboutWindow);
				dialogDone = TRUE;
				break;
		case updateEvt:
			BeginUpdate((WindowPtr)global.theEvent.message);
			DrawPicture(global.aboutPict, &global.aboutWindow->portRect);
			EndUpdate((WindowPtr)global.theEvent.message);
			break;
			default:
				break;
		}
	}
 	SetPort(oldPort);
}

void	HandlePrefDialog(void)
{
	long		dialogDone = FALSE;
	GrafPtr	oldPort;
	WindowPtr	whichWindow;
	char theChar;
	Rect	onrect		={17,174,31,190},
			offrect		={17,196,31,213},
			controlrect	={32,174,46,221}, 
			optionrect	={32,226,46,269},
			looponrect	={47,174,61,190},
			loopoffrect	={47,196,61,213};
	
 	GetPort(&oldPort);
 	SetPort(global.prefWindow);
	ShowWindow(global.prefWindow);
	SelectWindow(global.prefWindow);

	DrawPicture(global.prefPict, &global.prefWindow->portRect);
	ToggleBufButton();
	if(global.finderPlay)
		InvertRect(&onrect);
	else
		InvertRect(&offrect);
	if(global.hotKey == controlKey)
		InvertRect(&controlrect);
	else
		InvertRect(&optionrect);
	if(GetPlayLooping())
		InvertRect(&looponrect);
	else
		InvertRect(&loopoffrect);
		
	while(dialogDone == FALSE)
	{
		if(global.wNEpresent)
		WaitNextEvent(everyEvent, &global.theEvent, 0L, 0L);
		else
		{
			SystemTask();
			GetNextEvent(everyEvent, &global.theEvent);
		}
	
		switch(global.theEvent.what)
		{
			case keyDown:
			case autoKey:
				theChar = global.theEvent.message & charCodeMask;
				if(theChar == 0x0d)
				{
					HideWindow(global.prefWindow);
					dialogDone = TRUE;
				}
				break;
			case mouseDown:
				FindWindow(global.theEvent.where, &whichWindow);
				dialogDone = HandleContentClick(whichWindow, global.theEvent.where);
				if(dialogDone)
					HideWindow(global.prefWindow);
				break;
			case updateEvt:
				BeginUpdate((WindowPtr)global.theEvent.message);
				DrawPicture(global.prefPict, &global.prefWindow->portRect);
				ToggleBufButton();
				if(global.finderPlay)
					InvertRect(&onrect);
				else
					InvertRect(&offrect);
				if(global.hotKey == controlKey)
					InvertRect(&controlrect);
				else
					InvertRect(&optionrect);
				if(GetPlayLooping())
					InvertRect(&looponrect);
				else
					InvertRect(&loopoffrect);
				EndUpdate((WindowPtr)global.theEvent.message);
				break;
			default:
				break;
		}
	}
 	SetPort(oldPort);
}

Boolean	
HandleContentClick(WindowPtr clickWindow, Point where)
{
//	t, l, b, r
	Rect	b04krect	={2,174,16,189}, 
			b08krect	={2,193,16,208},
			b12krect	={2,213,16,235},
			b16krect	={2,240,16,262}, 
			b20krect	={2,266,16,289},
			b24krect	={2,293,16,316},
			onrect		={17,174,31,190},
			offrect		={17,196,31,213},
			controlrect	={32,174,46,221}, 
			optionrect	={32,226,46,269},
			looponrect	={47,174,61,190},
			loopoffrect	={47,196,61,213},
			donerect	={47,281,61,318};
	unsigned long	finalTick;
	if(clickWindow != global.prefWindow)	// we don't care about other windows
		return(TRUE);
	SetPort(global.prefWindow);
	GlobalToLocal(&where);				// set co-ordinates local to our window
	if(PtInRect(where,&b04krect))
	{
		ToggleBufButton();
		gPAPlayInfo.framesPerRead = 4096L;
		ToggleBufButton();
	}
	else if(PtInRect(where,&b08krect))
	{
		ToggleBufButton();
		gPAPlayInfo.framesPerRead = 8192L;
		ToggleBufButton();
	}
	else if(PtInRect(where,&b12krect))
	{
		ToggleBufButton();
		gPAPlayInfo.framesPerRead = 12288L;
		ToggleBufButton();
	}
	else if(PtInRect(where,&b16krect))
	{
		ToggleBufButton();
		gPAPlayInfo.framesPerRead = 16384L;
		ToggleBufButton();
	}
	else if(PtInRect(where,&b20krect))
	{
		ToggleBufButton();
		gPAPlayInfo.framesPerRead = 20480L;
		ToggleBufButton();
	}
	else if(PtInRect(where,&b24krect))
	{
		ToggleBufButton();
		gPAPlayInfo.framesPerRead = 24576L;
		ToggleBufButton();
	}
	else if(PtInRect(where,&onrect))
	{
		if(!global.finderPlay)
		{
			global.finderPlay = TRUE;
			InvertRect(&onrect);
			InvertRect(&offrect);
		}
	}
	else if(PtInRect(where,&offrect))
	{
		if(global.finderPlay)
		{
			global.finderPlay = FALSE;
			InvertRect(&onrect);
			InvertRect(&offrect);
		}
	}
	else if(PtInRect(where,&looponrect))
	{
		if(!GetPlayLooping())
		{
			SetPlayLooping(true);
			InvertRect(&looponrect);
			InvertRect(&loopoffrect);
		}
	}
	else if(PtInRect(where,&loopoffrect))
	{
		if(GetPlayLooping())
		{
			SetPlayLooping(false);
			InvertRect(&looponrect);
			InvertRect(&loopoffrect);
		}
	}
	else if(PtInRect(where,&controlrect))
	{
		if(global.hotKey == optionKey)
		{
			global.hotKey = controlKey;
			global.coldKey = optionKey;
			InvertRect(&optionrect);
			InvertRect(&controlrect);
		}
	}
	else if(PtInRect(where,&optionrect))
	{
		if(global.hotKey == controlKey)
		{
			global.hotKey = optionKey;
			global.coldKey = controlKey;
			InvertRect(&optionrect);
			InvertRect(&controlrect);
		}
	}
	else if(PtInRect(where,&donerect))
	{
		InvertRect(&donerect);
		Delay(2,&finalTick);	
		InvertRect(&donerect);
		Delay(4,&finalTick);	
		InvertRect(&donerect);
		Delay(6,&finalTick);	
		InvertRect(&donerect);
		Delay(8,&finalTick);	
		InvertRect(&donerect);
		return(TRUE);
	}
	return(FALSE);
}

void	ToggleBufButton()
{
	Rect	b04krect	={2,174,16,189}, 
			b08krect	={2,193,16,208},
			b12krect	={2,213,16,235},
			b16krect	={2,240,16,262}, 
			b20krect	={2,266,16,289},
			b24krect	={2,293,16,316};

	SetPort(global.prefWindow);
	if(gPAPlayInfo.framesPerRead == 4096L)
		InvertRect(&b04krect);
	else if(gPAPlayInfo.framesPerRead == 8192L)
		InvertRect(&b08krect);
	else if(gPAPlayInfo.framesPerRead == 12288L)
		InvertRect(&b12krect);
	else if(gPAPlayInfo.framesPerRead == 16384L)
		InvertRect(&b16krect);
	else if(gPAPlayInfo.framesPerRead == 20480L)
		InvertRect(&b20krect);
	else if(gPAPlayInfo.framesPerRead == 24576L)
		InvertRect(&b24krect);
}