#include <Timer.h>
#include <Sound.h>
#include "Event.h"
#include "Dialog.h"
#include "GetFinderSelection.h"
#include "SoundFileHeader.h"
#include "OpenSoundFile.h"
#include "CloseSoundFile.h"
#include "Play.h"
#include "Main.h"
#include "MyAppleEvents.h"

#ifdef powerc
extern TimerUPP			gDoMouseTask;
#endif

long	gNumberOption, gNumberControl;

extern GlowBalls	global;


//extern	DoubleBufPlayInfo gDBPI;
extern	PlayInfo	gPlayInfo;

void
NullEventTasks(void)
{
	long	itemsInList, position, windowHeight;
	static long lastPosition;
	static float lastTime;
	float	windowScale, time;
	
	AEDesc		docListA;
	AEKeyword	keywd;
	DescType	returnedType;
	EventRecord	theEvent;
	FSSpec		myFSS;
	OSErr		myErr;
	Size		actualSize;
	WDPBRec		wdpb;
	
	// check every nullEvent to see if playback has completed
	// then stop the play, and close the soundfile
	if(global.paused)
		UpdatePlayWindow(&global.theOpenSF, lastPosition);
	if(GetPlayState())
	{
		time = GetPlayTime();
		if(lastTime != time)
		{
			windowHeight = (global.theOpenSF.playWind->portRect.bottom - global.theOpenSF.playWind->portRect.top)
				- (global.theOpenSF.playWind->portRect.right - global.theOpenSF.playWind->portRect.left);
			windowScale = windowHeight;
			lastTime = time;
			position = (unsigned long)((windowScale * (time/gPlayInfo.length)));
			if(position != lastPosition)
			{
				CLIP(position, 0, windowHeight);
				UpdatePlayWindow(&global.theOpenSF, position);
				lastPosition = position;
			}
		}
		UpdatePlay();
		if(GetPlayState() == false)
		{
			global.paused = FALSE;
			StopPlay(false);
			CloseSoundFile(&global.theOpenSF);
		}
	}
	
	// look in the OS event queue
	// if the hotKey (control or option) is pressed and finderPlay is enabled
	// start up a FinderPlay()
	
	OSEventAvail(0xffff,&theEvent);
	if((theEvent.modifiers & global.hotKey) && global.finderPlay && IsFinderFront())
	{
		// if there is no appleevent query in progress
		// then ask the finder what (if any) file is selected
		// and play it if it is a soundfile
		if(!global.eventActive)
		{
			global.eventActive = TRUE;
			docListA = GetFinderSelection();
			myErr = AECountItems (&docListA, &itemsInList);

			// now get each descriptor record from the list, coerce
			// the returned data to an FSSpec record, and print the
			// associated file
			if (itemsInList > 0) 
				{
					myErr = AEGetNthPtr(&docListA, 1, typeFSS, &keywd, &returnedType, (Ptr)&myFSS, sizeof(myFSS), &actualSize);
					myErr = AEDisposeDesc(&docListA);
					global.eventActive = FALSE;	// Allow further event processing
					if(!GetPlayState() || (EqualString(myFSS.name,global.theOpenSF.sfSpec.name,TRUE,TRUE)==FALSE))
					{
						wdpb.ioNamePtr = "\p";
						wdpb.ioWDDirID = myFSS.parID;
						wdpb.ioVRefNum = myFSS.vRefNum;
						wdpb.ioWDProcID = 0;
						PBOpenWD(&wdpb, FALSE);
						if(GetPlayState())
							StopPlay(false);
						if(global.fileOpen)
							CloseSoundFile(&global.theOpenSF);
						if(OpenSoundFile(myFSS) != FALSE)
						{
							SetCursor(&qd.arrow);
							StartPlay(&global.theOpenSF, 0.0, 0.0);
							UpdatePlayWindow(&global.theOpenSF, 0);
						}
					}
			}
			else
			{
				myErr = AEDisposeDesc(&docListA);
				global.eventActive = FALSE;	// Allow further event processing
			}
		}
	}
	else if((theEvent.modifiers & global.coldKey) && global.finderPlay && IsFinderFront())
	{
		if(GetPlayState())
			StopPlay(false);
		if(global.fileOpen)
			CloseSoundFile(&global.theOpenSF);
	}
}

/* Globals */
TMTask gTimeTaskA;	/* global Time Task record */

OSErr 
InstallTask (void)
{
#ifdef powerc
	gTimeTaskA.tmAddr = (TimerUPP)gDoMouseTask;
#else
	gTimeTaskA.tmAddr = (TimerUPP)DoMouseTask;
#endif
	gTimeTaskA.tmWakeUp = 0L;
	gTimeTaskA.tmReserved = 0L;
	InsXTime((QElemPtr)&gTimeTaskA);
	PrimeTime((QElemPtr)&gTimeTaskA, 15);
}

OSErr
RemoveTask(void)
{
	RmvTime((QElemPtr)&gTimeTaskA);
}

void 
DoMouseTask()
{
	EventRecord	theEvent;
	long	nextCheck;
	
	nextCheck = 15;
	if(OSEventAvail(0xffff,&theEvent))
	{
		if(theEvent.modifiers & controlKey)
		{
			gNumberControl++;
			nextCheck = 100;
		}
		if(theEvent.modifiers & optionKey)
		{
			gNumberOption++;
			nextCheck = 100;
		}
	}
	PrimeTime((QElemPtr)&gTimeTaskA, nextCheck);
}
