#include "Menu.h"
#include "Dialog.h"
#include <Sound.h>
#include "SoundFileHeader.h"
#include "Play.h"
#include "CloseSoundFile.h"
#include "OpenSoundFile.h"
#include "Main.h"

#define	BASE_RES_ID			128

MenuHandle	gAppleMenu, gFileMenu, gEditMenu, gFontMenu;
extern GlowBalls	global;

void
MenuBarInit(void)
{
	Handle	myMenuBar;
	
	myMenuBar = GetNewMBar(BASE_RES_ID);
	SetMenuBar(myMenuBar);
	gAppleMenu = GetMenuHandle(APPLE_MENU_ID);
	gFileMenu = GetMenuHandle(FILE_MENU_ID);
	gEditMenu = GetMenuHandle(EDIT_MENU_ID);
	gFontMenu = GetMenuHandle(FONT_MENU_ID);
	AppendResMenu(gAppleMenu, 'DRVR');
	AppendResMenu(gFontMenu, 'FONT');
	DrawMenuBar();
}

void	HandleMenuChoice(long menuChoice)
{
	short	theMenu;
	short theItem;
	
	if(menuChoice != 0)
	{
		theMenu = HiWord(menuChoice);
		theItem = LoWord(menuChoice);
		switch(theMenu)
		{
			case APPLE_MENU_ID:
				HandleAppleChoice(theItem);
				break;
			case FILE_MENU_ID:
				HandleFileChoice(theItem);
				break;
			case EDIT_MENU_ID:
				HandleEditChoice(theItem);
				break;
			case FONT_MENU_ID:
				HandleFontChoice(theItem);
				break;
		}
		HiliteMenu(0);
	}
}

void	HandleAppleChoice(short theItem)
{
	Str255	accName;
	short		accNumber;
	
	switch	(theItem)
	{
		case ABOUT_ITEM:
			HandleAboutDialog();
			break;
		default:
			GetMenuItemText(gAppleMenu,theItem,accName);
			accNumber = OpenDeskAcc(accName);
			break;
	}
}

void	HandleFileChoice(short theItem)
{
	FSSpec fileSpec;
	static float pauseTime;
			
	switch(theItem)
	{
		case PLAY_ITEM:
			fileSpec.vRefNum = nil;
			if(GetPlayState())
				StopPlay(false);
			if(global.fileOpen)
				CloseSoundFile(&global.theOpenSF);
			if(OpenSoundFile(fileSpec) != FALSE)
			{
				SetCursor(&qd.arrow);
				StartPlay(&global.theOpenSF, 0.0, 0.0);
				UpdatePlayWindow(&global.theOpenSF, 0);
			}
			break;
		case STOP_ITEM:
			if(global.paused)
			{
				global.paused = FALSE;
				CloseSoundFile(&global.theOpenSF);
			}
			if(GetPlayState())
			{
				StopPlay(false);
				CloseSoundFile(&global.theOpenSF);
			}
			break;
		case PAUSE_ITEM:
			if(global.paused)
			{
				global.paused = FALSE;
				StartPlay(&global.theOpenSF, pauseTime, 0.0);
			}
			else
			{
				if(GetPlayState())
				{
					pauseTime = GetPlayTime();
					StopPlay(false);
					global.paused = TRUE;
				}
			}
			break;
		case PREFS_ITEM:
			HandlePrefDialog();
			break;
		case QUIT_ITEM:
			TerminateInstantPlayer();
			break;
	}
}

void HandleEditChoice(short theItem)
{
	switch(theItem)
	{
		case UNDO_ITEM:
			break;
		case CUT_ITEM:
			break;
		case COPY_ITEM:
			break;
		case PASTE_ITEM:
			break;
	}
}

void HandleFontChoice(short theItem)
{
	Str255 itemString;
	long	iItemCnt, i;
	
	iItemCnt = CountMItems(gFontMenu);
	for(i=1; i<=iItemCnt; i++)
			CheckItem(gFontMenu, i, FALSE);
	CheckItem(gFontMenu, theItem, TRUE);
	GetMenuItemText(gFontMenu,theItem,itemString);
	GetFNum(itemString, &global.fontNum);
	global.fontChanged = TRUE;
}